
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>React动画框架简介 / iVAN</title>

    <meta name="description" content="React动画框架简介 由于 React 加持了虚拟 DOM 等诸多特性,所以在 React 上实现常规的动画效果有一些特别之处.本文不会深入探讨 React 对动画的处理逻辑,只会简单地演示如何使用 React 创建动画效果. React 插件 React 官方提供了两个插件用于处理动画效果:一个是偏底层的 react-addons-transition-group,一个是在前者基础上进一步封装的 react-addons-css-transition-group.在使用它们之前,需要先检查下你使用的是哪种类型的 R">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">React动画框架简介</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>由于 React 加持了虚拟 DOM 等诸多特性，所以在 React 上实现常规的动画效果有一些特别之处。本文不会深入探讨 React 对动画的处理逻辑，只会简单地演示如何使用 React 创建动画效果。</p>
<h1>React 插件</h1>
<p>React 官方提供了两个插件用于处理动画效果：一个是偏底层的 react-addons-transition-group，一个是在前者基础上进一步封装的 react-addons-css-transition-group。在使用它们之前，需要先检查下你使用的是哪种类型的 React 版本，一般通过 npm 安装的 React 默认不会安装这两个插件，需要手动安装它们：</p>
<pre><code>npm install --save react-addons-transition-group
react-addons-css-transition-group
</code></pre>
<p>在这里先介绍 react-addons-css-transition-group 的使用方式，使用它可以快速利用 CSS 的能力实现组件的入场和出场动画。使用该插件实现 React 动画需要两个部分的协作，首先是 JS 部分的组件：</p>
<pre><code>// 非完整代码
class App extends React.Component {
    state = {
        itemList: [{
            key: getRandomKey(),
            color: colorSet[getRandomIndex(0, 10)]
        }]
    };
    render () {
        const { itemList } = this.state;
        let itemNodeList = [];
        itemList.forEach((item) =&gt; {
            itemNodeList.push(
                &lt;div
                    // 重点：CSSTransitionGroup 的直接子组件必须有一个独一无二的 key 值
                 key={item.key}
                    className="item"
                    style={{ backgroundColor: `${item.color}` }}
                    onClick={() =&gt; this.handleRemove(item.key)}&gt;
                    {item.key}
                &lt;/div&gt;
            );
        });
        return (
            &lt;div id="color-wrapper"&gt;
                &lt;button onClick={this.handleAdd}&gt;ADD&lt;/button&gt;
              &lt;CSSTransitionGroup
                 component="div"
                 className="color-set"
                transitionName="todo"
                transitionAppear={true}
                 transitionAppearTimeout={500}
                 transitionEnterTimeout={500}                          transitionLeaveTimeout={300}&gt;
                  {itemNodeList}
              &lt;/CSSTransitionGroup&gt;
            &lt;/div&gt;
        );
    }
}
</code></pre>
<p>在 CSSTransitionGroup 组件上，我们声明了一堆以 transition 开头的属性，这些属性被用来控制动画效果：</p>
<ul>
<li>transitionName，写样式时的前缀，比如这里的值为 todo，那么 CSS 的类型就应该是todo-enter、todo-leave 等等</li>
<li>transitionAppear，布尔值，是否在所有组件挂载时触发动画</li>
<li>transitionEnterTimeout，控制入场动画的时长</li>
<li>transitionLeaveTimeout，控制退场动画的时长</li>
<li>transitionAppearTimeout，控制所有组件挂载的动画时长</li>
</ul>
<p>默认情况下，CSSTransitionGroup 组件会被渲染为 span 标签，如果你想修改标签类型，可以使用 component 属性进行修改。其次是 CSS 部分的样式，CSS 中类选择器遵循类似 ${transitionName}-appear 的命名格式：</p>
<pre><code>.todo-appear {
    opacity: 0.01;
    transform: translateY(-50px);
}
.todo-appear.todo-appear-active {
    opacity: 1;
    transform: translateY(0px);
    transition: all 500ms ease-in;
}
.todo-enter {
    opacity: 0.01;
    transform: translateY(-50px);
}
.todo-enter.todo-enter-active {
    opacity: 1;
    transform: translateY(0px);
    transition: all 500ms ease-in;
}
.todo-leave {
    opacity: 1;
    transform: translateY(0px);
}
.todo-leave.todo-leave-active {
    opacity: 0.01;
    transform: translateY(-50px);
    transition: all 300ms ease-in;
}
</code></pre>
<p>通过上述两部分的结合，当我们删除 itemNodeList 中的某个组件时，React 会立即通过 key 找到这个组件，然后为其添加 todo-leave 类名，并瞬间添加 todo-leave-active 类名，在 500 毫秒之后移出该组件。</p>
<p>这种动画处理方式的优点如下：</p>
<ul>
<li>简单快速，与 React 的融合性好，性能有保障</li>
<li>可以使用 Sass、Less 等预处理器，提高开发效率</li>
<li>易于上手，无第三方依赖，也就是无门的动画处理模块，这里的插件只是将类选择器应用到相关的节点上</li>
</ul>
<p>不过缺点也很多：</p>
<ul>
<li>只有入场和出场动画，无法实现复杂动画</li>
<li>组件之间的动画效果是独立的，无互动，动画效果生硬 要求和限制条件多</li>
<li>使用 CSS Modules 需要硬编码，也就是使用CSSTransitionGroup 组件自定义类名的功能</li>
</ul>
<p>最后，列出使用 React 插件开发动画的几点要求：</p>
<ul>
<li>组件必须挂载才能实现动画</li>
<li>组件必须设定独一无二的 key 值</li>
<li>transitionName 必须与 CSS 中的样式类名保持一致</li>
</ul>
<p>从上面的示例可以看出，CSSTransitionGroup 组件主要用来在组件入场和出场时给 DOM 节点添加类名，相当于是与 CSS 的结合，那么我们是否能够通过 JS 生成行内样式，然后添加到 DOM 节点，实现更加灵活的动画效果呢？答案是可以的，React 提供了 ReactTransitionGroup 组件供开发者在以下六个阶段向 DOM 节点注入数据：</p>
<ul>
<li>componentWillAppear(callback)</li>
<li>componentDidAppear()</li>
<li>componentWillEnter(callback)</li>
<li>componentDidEnter()</li>
<li>componentWillLeave(callback)</li>
<li>componentDidLeave()</li>
</ul>
<h1>React Motion</h1>
<p>使用react-motion之前需要先安装库，安装命令如下：</p>
<pre><code>npm install --save react-motion
</code></pre>
<p><a href="http://img.blog.csdn.net/20170927201623772?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveGlhbmd6aGlob25nOA==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA5MjcyMDE2MjM3NzI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZUdsaGJtZDZhR2xvYjI1bk9BPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a></p>
<p>对于绝大多数的动画组件，我们往往不希望对动画属性（宽高、颜色等）的变化时间做硬编码处理，react-motion 提供的 spring 函数就是用来解决这一需求的，它可以逼真地模仿真实的物理效果，也就是我们常见的各类缓动效果。react-motion 一共提供了五个 API 接口，其中前两个是辅助类函数，后三个是具体的动画组件：</p>
<ul>
<li>spring，声明动画的缓动效果，比如 spring(10, {stiffness: 120, damping: 17})，10是目标值，stiffness 是弹性动画的刚度值，影响弹性，damping 是弹性动画的阻尼；</li>
<li>presets，预置的缓动效果，比如 spring(10, preset.gentle)；</li>
<li>Motion，该动画组件内部往往只有一个直接子组件，也就是只有一个动画目标；</li>
<li>StaggerdMotion，该动画组件内部有一个或多个直接子组件，多个子组件之间的动画效果由关联性；</li>
<li>TransitionMotion，该动画组件内部的一个或多个组件可以卸载或挂载，提供 Enter 和 Leave 动画效果；</li>
</ul>
<p>示例代码如下：</p>
<pre><code>&lt;Motion
    defaultStyle={{x: 0}}
    style={{x: spring(10)}}
    onRest={() =&gt; void}&gt;
    {
        interpolatingStyle =&gt; (
            &lt;div style={interpolatingStyle}&gt;{interpolatingStyle.x}&lt;/div&gt;
        )
    }
&lt;/Motion&gt;
</code></pre>
<p>上面代码演示了 Motion 组件的最基础使用方法。</p>
<ul>
<li>defaultStyle?: PlainStyle，可选参数，PlainStyle 指的就是 React 常用作行内样式的对象类型的 {width: '10px', height: '10px' }，见名知意，为动画设定初始值</li>
<li>style: Style，必选参数，指定动画完成的目标值，并设定动画的变化类型，实际上是一种数据驱动的形式</li>
<li>onRest?: () =&gt; void，可选参数，在动画完成后调用</li>
<li>children: (interpolatedStyle: PlainStyle) =&gt;ReactElement，必选函数，接收一个从初始值到目标值中间的值，这个值不断变化，用于渲染子组件的样式</li>
</ul>
<p>关于 StaggerdMotion 组件和 TransitionMotion 组件这里就不多做介绍了，有兴趣的话请阅读<a href="https://github.com/chenglou/react-motion" rel="external nofollow noreferrer">官方文档</a>。</p>
<h1>GSAP</h1>
<p>GSAP 是一个老牌的专业级动画库，从古老的 Flash 动画时代一直兴盛至今，它是一个商业产品，虽然开发者可以免费下载源代码，但如果要在商业活动中使用它，请购买相关的会员。如果你没有使用过 GSAP，建议阅读<a href="http://www.w3cplus.com/blog/tags/524.html" rel="external nofollow noreferrer">GSAP</a>，接下来，我们尝试将 GSAP 融入到 React 的开发中。</p>
<p>将 GSAP 与 React 结合最简单的方式是，使用 ref 或 findDOMNode()。例如：</p>
<pre><code>// 导入通过 NPM 安装的 GSAP
import TweenMax from 'gsap';
// 保存 ref 指向的真实节点
let refNode;
class App extends React.Component {
    componentDidMount () {
        TweenMax.to(refNode, 2, {
            x: '+=200px',
            backgroundColor: '#2196f3'
        });
        // TweenMax 可以做什么？
        // 暂停
        tween.pause();
        // 继续播放
        tween.resume();
        // 反转播放
        tween.reverse();
        // 跳转到1s进度处开始播放
        tween.seek(1);
        // 重播
        tween.restart();
        // 动画变为三倍速
        tween.timeScale(3);
    }
    render () {
        return (
            &lt;div
                id="ball"
                ref={c =&gt; (refNode = c)}
                style={{
                    width: '100px',
                    height: '100px',
                    margin: '100px',
                    borderRadius: '50%',
                    backgroundColor: 'red'
                }}&gt;
            &lt;/div&gt;
        );
    }
}
</code></pre>
<p>TweenMax 的强大在于多年的动画开发经验所积累的技术底蕴，非一朝一夕可以被替代，上面简单演示了 TweenMax 的一小部分功能，像是 Timeline 的用法就没有介绍，当需要组织的元素越来越多时，其灵活性就会越加凸显。</p>
<p><a href="http://img.blog.csdn.net/20170927204411730?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveGlhbmd6aGlob25nOA==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA5MjcyMDQ0MTE3MzA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZUdsaGJtZDZhR2xvYjI1bk9BPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a></p>
<p>GSAP 与 React 结合的另一种方式是使用 ReactTransitionGroup 组件，ReactTransitionGroup 组件提供了六个生命周期方法：</p>
<ul>
<li>componentWillAppear(callback)</li>
<li>componnetDidAppear()</li>
<li>componentWillEnter(callback)</li>
<li>componnetDidEnter()</li>
<li>componentWillLeave(callback)</li>
<li>componnetDidLeave()</li>
</ul>
<p>示例：</p>
<pre><code>class Box extends React.Component {
    componentWillEnter (callback) {
        const el = ReactDOM.findDOMNode(this);
        TweenMax.fromTo(el, 0.3, {y: 100, opacity: 0}, {y: 0, opacity: 1, onComplete: callback});
    }
    componentWillLeave (callback) {
        const el = ReactDOM.findDOMNode(this);
        TweenMax.fromTo(el, 0.3, {y: 0, opacity: 1}, {y: -100, opacity: 0, onComplete: callback});
    }
    render () {
        return (
            &lt;div
                style={{
                    width: '100px',
                    height: '100px',
                    margin: '100px',
                    borderRadius: '50%',
                    backgroundColor: 'red'
                }}&gt;
            &lt;/div&gt;
        );
    }
}
class App extends React.Component {
    state = {
        show: true
    }
    handleToggle = () =&gt; {
        this.setState({
            show: !this.state.show
        });
    }
    render () {
        return (
            &lt;div className="wrapper"&gt;
                &lt;button onClick={this.handleToggle}&gt;Toggle&lt;/button&gt;
                &lt;TransitionGroup&gt;
                    { this.state.show &amp;&amp; &lt;Box key="a"&gt;&lt;/Box&gt; }
                &lt;/TransitionGroup&gt;
            &lt;/div&gt;
        );
    }
}
</code></pre>
<h1>总结</h1>
<p>对于上面提到的几个动画框架，做一个简单的对比：</p>
<ul>
<li>易用性：CSSTransitionGroup &gt;= React Motion &gt; GSAP</li>
<li>可维护性：看代码量和技术能力，CSSTransitionGroup 最简单</li>
<li>用户体验：GSAP &gt;= React Motion &gt; CSSTransitionGroup</li>
<li>对复杂动画的支持程度：GSAP &gt; React Motion &gt; CSSTransitionGroup</li>
</ul>
<p><a href="http://img.blog.csdn.net/20170927204934877?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveGlhbmd6aGlob25nOA==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA5MjcyMDQ5MzQ4Nzc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZUdsaGJtZDZhR2xvYjI1bk9BPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a></p>
<p>参考资料<br /><a href="https://facebook.github.io/react/docs/animation.html" rel="external nofollow noreferrer">React Animation</a><br /><a href="https://github.com/chenglou/react-motion" rel="external nofollow noreferrer">React Motion</a><br /><a href="https://css-tricks.com/comparison-animation-technologies/" rel="external nofollow noreferrer">A Comparison of Animation Technologies</a><br /><a href="http://acgtofe.com/posts/2016/05/gsap-for-animation-pro" rel="external nofollow noreferrer">GSAP，专业的Web动画库</a><br /><a href="https://github.com/azazdeaz/react-gsap-enhancer" rel="external nofollow noreferrer">React GSAP Enhancer</a><br /><a href="https://medium.com/@cheapsteak/animations-with-reacttransitiongroup-4972ad7da286#.o7ta17de0" rel="external nofollow noreferrer">Animations with ReactTransitionGroup</a><br /><a href="http://www.shanemielke.com/archives/usopen-sessions/" rel="external nofollow noreferrer">GSAP Examples</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:53:46</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/react/" title="react">react</a>, <a href="https://www.iamivan.net/tag/spring/" title="spring">spring</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>React动画框架简介的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxRw0b.html" rel="bookmark">KJFrameForAndroid框架简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android app一般性架构设计 一.UI层(Activity+Fragment基类设计+部分自定义控件) KJActivity(Activity继承链的规范) I_KJActivity,KJFrameActivity接口协议,将Activity需要实现的方法提取成一个接口. I_BroadcastReg,规范Activity中广播接受者注册的接口协议 I_SkipActivity,规范Activity跳转的接口协议 I_KJActivity基类中集成了网络请求及其回调的方法.其中持有Thr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRPo3z.html" rel="bookmark">iOS网络编程之一&mdash;&mdash;iOS网络框架简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS网络编程之一--iOS网络框架简介 一.引言         通过网络,一款应用才能够内容丰富,才能够完成用户操作与后台数据的交互.网络编程是移动应用或游戏开发开发中不可缺少的技术.iOS原生的网络框架也十分完善,其中涉及到的许多类和协议用于处理网络开发中的各种需求 二.URL加载框架     iOS的URL加载系统包含许多类与协议,这些类和协议相互协作完成URL加载的信息配置,协议支持,身份验证,cookie和缓存等功能.APPLE开发文档中有如下图表示他们之间的关系:     关于UR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYj3Lxp.html" rel="bookmark">《企业级ios应用开发实战》一2&period;3 Cocoa Touch 框架简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 Cocoa Touch 框架简介 Cocoa Touch框架是进行iPhone应用程序开发工作的主要框架,主要包括UIKit和Foundation(NS)框架,这些库统称为Cocoa Touch框架.该框架完全是面向对象的,它是Cocoa框架的子集. 注意:Cocoa框架早先是用于Mac OS X上的一个面向对象的应用程序快速开发(Rapid Application Development,RAD)框架,包含了Foundation和App Kit框架,可用于开发Mac OS X系统的应用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdm0V6z.html" rel="bookmark">Java的Struts框架简介与环境配置教程&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Struts2是流行和成熟的基于MVC设计模式的Web应用程序框架. Struts2不只是Struts1下一个版本,它是一个完全重写的Struts架构. WebWork框架开始以Struts框架为基础,其目标是提供一个加强和改进框架Struts来使web开发的开发人员更容易. 一段时间后,WebWork框架和Struts社区联手打造的著名的Struts2框架. Struts 2框架的特点: 这里有一些强大的功能,可能会迫使你考虑Struts2: POJO表单和POJO动作 - Struts2的S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p52r1Rz.html" rel="bookmark">Android Transition Framework详解---超炫的动画框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 早在Android 4.4,Transition 就已经引入,但在5.0才得以真正的实现.而究竟Transition是用来干嘛的呢.接下来我将通过实例和原理解析来分析下Google这个强大的动画框架. 先来张效果图镇住场面   这个效果下文会介绍如何实现,不过要先理解透这个框架的一些基础概念. Transition Framework 核心就是根据Scene(场景,下文解释)的不同帮助开发者们自动生成动画.通常主要是通过以下几个方法开启动画. TransitionManager.go()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba4KNmz.html" rel="bookmark">10 个顶级 JavaScript 动画框架推荐</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用JavaScript可以做出一些引人注目的动画效果,但通常不太容易实现.本文为你整理了10个非常优秀的JavaScript动画框架,使用它们你可以轻松实现动画效果.  1. Raphaël  Raphaël是一个小型JavaScript库,用于简化你的Web矢量图形工作.如果你想创建独特的图表或图形的裁剪和旋转部件,你可以使用这个简单方便的库来实现.  源码 + 演示  2. Processing.js  该框架主要针对不想使用Flash或Java applets进行图片编程以及Web交互的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrvZ4M.html" rel="bookmark">Flex框架简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们在学习一门技术的时候,总是习惯于看一下这门技术的名字是哪些英文单词的缩写.这样的例子很多,比如ASP是Active Server Page的缩写. 但找了好久,没有找到Flex是哪些单词的缩写.因此按我自己的理解,Flex是ADOBE公司推出的一个技术名词,而并非是什么英文缩写. 简介 Flex 是一个高效.免费的开放源框架,可用于构建具有表现力的 Web 应用程序,这些应用程序利用 Adobe Flash Player 和 Adobe AIR 运行时跨浏览器.桌面和操作系统实现一致的部署.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/wzVe5Dp.html" rel="bookmark">Extjs框架简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				序言 ExtJS是一种主要用于创建前端用户界面,是一个与后台技术无关的前端ajax框架. 功能丰富,无人能出其右 无论是界面之美,还是功能之强,ext的表格控件都高居榜首. 单选行,多选行,高亮显示选中的行,推拽改变列宽度,按列排序,这些基本功能咱们就不提了. 自动生成行号,支持checkbox全选,动态选择显示哪些列,支持本地以及远程分页,可以对单元格按照自己的想法进行渲染,这些也算可以想到的功能. 再加上可编辑grid,添加新行,删除一或多行,提示脏数据,推拽改变grid大小,grid之间推			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8gK9M.html" rel="bookmark">AJAX框架&amp;amp&semi;简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|ajax框架 Ajax,使用它可以构建更为动态和响应更灵敏的Web应用程序.该方法的关键在于对浏览器端的JavaScript.DHTML和与服务器异步通信的组合.本文也演示了启用这种方法是多么简单:利用一个Ajax框架(指DWR)构造一个应用程序,它直接从浏览器与后端服务进行通信.如果使用得当,这种强大的力量可以使应用程序更加自然和响应灵敏,从而提升用户的浏览体验. 该应用程序中所使用的示例代码已打包为单独的WAR文件,可供下载. 简介 术语Ajax用来描述一组技术,它使浏览器可以为用			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bomAdp.html" rel="bookmark" class="title">郭姐看网络之：从文化衫谈网站品牌</a>
					<div>
						找查发(www.zhaochafa.com)的第一批文化衫,诞生于三个月前.在本地的站长圈子里,貌似当时尚未有为自己的网站印制文化衫的习惯(题外话:转瞬间三个月过去了,现在身边越来越多的站长/网络公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8vrZb.html" rel="bookmark" class="title">通过JAVAScript实现页面自适应</a>
					<div>
						javascript|页面|自适应     有时候,我们可能需要象新版的Yahoo邮箱一样,让一些数据显示块可以根据页面大小进行自适应.事实并不难,但是如果单纯用CSS控制的话,往往不能完全实现我们要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA85eb.html" rel="bookmark" class="title">优化推广二者兼顾 SEO软文如何一箭双雕</a>
					<div>
						在广大中小网站千军万马争过SEO独木桥的今天,SEO软文写作越来越受到SEOER们的高度重视--但必须指出的是,好的SEO软文并不仅仅是带上一个外链,不被网站管理员认为你是必须删除的AD就万事大吉的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYPVrb.html" rel="bookmark" class="title">初学Delphi嵌入汇编&lbrack;18&rsqb;</a>
					<div>
						汇编中的SHL(左移).SHR(右移)命令也是和 Delphi 一样的.var ByteNum: Byte; begin //右移 shr asm mov al, 10000000B {128} sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7Geab.html" rel="bookmark" class="title">Oracle技术：Shell字符串比较</a>
					<div>
						Shell 中整数比较方法及字符串的比较方法,如等于,不等于,大于,大于等于,小于,等等. 二元比较操作符,比较变量或者比较数字.注意数字与字符串的区别. ---------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4oR9p.html" rel="bookmark" class="title">vi命令速查表</a>
					<div>
						vi命令如何常用,放于此以备查. % vi file : Last line mode ----&gt; Command mode ----&gt; Insert mode &lt;---- &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2lK1M.html" rel="bookmark" class="title">Excel2007教程：激活工作表</a>
					<div>
						Excel2007基础教程:激活工作表 在任意给定的时间,只有一个工作簿是活动工作簿.在活动工作簿中,活动工作表也只有一张.要激活一张不同的表,只需单击位于工作簿窗口底部的工作表标签,也可通过使用下列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKyKNp.html" rel="bookmark" class="title">Win8&period;1系统Wpprecorder&period;sys故障导致蓝屏怎么办？</a>
					<div>
						Win8.1系统Wpprecorder.sys故障导致蓝屏怎么办?   具体方法: 1.进入Win8.1恢复环境(WINRE)环境(在自动修复失败之后会出现蓝色底菜单选项),高级选项菜单,打开命令提示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLkAkb.html" rel="bookmark" class="title">无法删除空文件夹怎么办？</a>
					<div>
						问:我电脑上有一个文件夹,是用来放图片的.后来我删除了里面的图片,变成了空文件夹,于是我想删除文件夹,但电脑提示:&quot;无法删除文件:文件正在被另一个人或程序使用&quot;,后来我用unloc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo61ngz.html" rel="bookmark" class="title">photoshop制作红色火焰水晶字</a>
					<div>
						  制作红色火焰水晶字的具体操作流程: 步骤一.新建一个800*600像素的窗口,分辨率72像素即可.如图所示: 步骤二.新建一层,在新建图层上拉径向渐变.渐变的色彩值为&quot;#6c0025&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr333Vp.html" rel="bookmark" class="title">win8&period;1系统笔记本连接使用HDMI高清线连接电视后没声音如何解决</a>
					<div>
						  win8.1系统笔记本连接使用HDMI高清线连接电视后没声音如何解决?win8.1系统笔记本有一个HDMI接口,只要使用HDMI高清线就可以连接显示器.液晶电视进行分屏显示,这样就可以在大屏幕下进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr33emp.html" rel="bookmark" class="title">笔记本开机不显示解决方法</a>
					<div>
						最近自己的笔记本打开电源以后,只听到硬盘转动,但是显示器就是不亮,电源指示灯也是亮的,但是放在那里几天以后,再开机就又亮了,画面又恢复正常了,但是用一段时间不一定哪天又这样了,这个是怎么回事呢? 如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NZm7z.html" rel="bookmark" class="title">获取token</a>
					<div>
						问题描述 想自己做个iOS通讯Demo,又想使用授权注册,但是不会获取token,请问token在程序中怎么获取? 解决方案 解决方案二:token在iOS端无法获取,只能通过rest接口获取.解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAWJZM.html" rel="bookmark" class="title">如何分析用户反馈数据&quest; &vert; 下</a>
					<div>
						在&lt;理解用户反馈最佳实践指南&gt;的第一部分中,我们主要着眼于如何分析和理解那些对我们的产品有重要影响的反馈类型. 一旦你决定了应该聚焦于哪些反馈以后,接下来,要如何针对用户的反馈制定公司的可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NqdAz.html" rel="bookmark" class="title">Chrome 正在变得越来越难用，你有同感么？</a>
					<div>
						今天早上闲来无事,我在 Twitter 吐槽 Mac 系统上的 Chrome 越更新越不稳定,越臃肿.没想到引来了诸多回复.其中最令人惊讶的是:所有的回复都一致认为 Chrome 越来越慢了. 不光是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVXXOb.html" rel="bookmark" class="title">云基地处处体现云气息</a>
					<div>
						摘要: 祥云基地.中关村云计算产业基地.中关村云广场在一年时间内,中关村软件园已经多了三个和云计算有关的头衔.作为国内互联网产业的发源地和创新高地,一向在新兴产业领域处于 祥云基地.中关村云计算产业基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAZJaM.html" rel="bookmark" class="title">android-activity1和activity2，1和2互相切换，怎么修改1的显示状态并修改1中的某个变量</a>
					<div>
						问题描述 activity1和activity2,1和2互相切换,怎么修改1的显示状态并修改1中的某个变量 安卓中有activity1和activity2,1切到2再切回1,怎么修改1的显示状态并修改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrlG0M.html" rel="bookmark" class="title">haar-like 人脸检测扫描窗口放大问题</a>
					<div>
						问题描述 haar-like 人脸检测扫描窗口放大问题 请问大牛们,我在做基于adaboost算法的haar-like人脸检测,得到分类器之后,在检测过程中,如何将扫描窗口依次放大1.25倍?我的困难 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKAjrz.html" rel="bookmark" class="title">惠普：绿色亦可&OpenCurlyDoubleQuote;廉价&rdquo;</a>
					<div>
						如今越来越多的企业已经开始在&quot;绿色环保&quot;的概念上掘金,期望借此让消费者能高价买单.遗憾的是,效果却与预想相距太大 文/本刊记者 李国柱 当绿色环保成为世界不可阻挡的潮流时,占据打印 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Ry7Zb.html" rel="bookmark" class="title">多线程-关于Vector的线程安全问题</a>
					<div>
						问题描述 关于Vector的线程安全问题 一个线程做删除该集合元素的同时,其他线程做查询工作,会有安全问题吗 解决方案 当然会有安全问题,比如说另一个线程持有一个迭代器对象,那么会导致迭代器状态无效. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKRdXb.html" rel="bookmark" class="title">获取IP的用法过时</a>
					<div>
						问题描述 SocketsocketListen=newSocket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);IPA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RR26z.html" rel="bookmark" class="title">java中new long&lpar;3&rpar;等于多少</a>
					<div>
						问题描述 java中new long(3)等于多少 java中new long(3)等于多少,long(3)等于多少 java中还自带long()方法吗long不是一个数据类型吗,怎么感觉它像是一个类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYyl7p.html" rel="bookmark" class="title">linux下ntp时间服务器配置及客户端注意事项</a>
					<div>
						折腾了半天,里标记一下,以备后用. 一.同步环境 1.ntp客户端:windows7,关闭了防火墙,ip:192.168.1.101 2.ntp服务端:windows7下虚拟机redhat5.5,关闭 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z6Eqz.html" rel="bookmark" class="title">我的Android进阶之旅------&amp;amp&semi;gt&semi;解决DownloadManager报错java&period;lang&period;SecurityException&colon; Invalid value for visibility&colon; 2</a>
					<div>
						1.问题描述 今天使用Android系统的DownloadManager进行下载操作时,爆了如下所示的错误: java.lang.RuntimeException: Unable to start s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKjlYb.html" rel="bookmark" class="title">这是我的java加密日记本程序  哪里错了啊！！求解释</a>
					<div>
						问题描述 这是我的java加密日记本程序 哪里错了啊!!求解释 public class Diary { public static void main(String args[])throws Ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBdrqb.html" rel="bookmark" class="title">微软新任CEO薪酬方案全析</a>
					<div>
						微软在刚公布的文件中披露了新任CEO萨蒂亚·纳德拉(Satya Nadella)的薪酬方案,大伙儿看过之后纷纷感叹,接下来几年的时间里纳德拉买啤酒的钱不缺了. 让我们先来看一组数字,纳德拉最低将获得1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeZ3Bb.html" rel="bookmark" class="title">图片-各位大神！帮帮忙，这个问题困扰好几天了</a>
					<div>
						问题描述 各位大神!帮帮忙,这个问题困扰好几天了 解决方案 要看dbhelper的executereader怎么写的.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX3xVb.html" rel="bookmark" class="title">java&period;lang&period;String的cloassloader为null的原因</a>
					<div>
						问题描述 本意是取自定义对象的classloader,但由于参数错误,传入了一个string对象.发现String对象调用getClassLoader()的返回为null.查看了JDK1.6的源码,对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKq0Rap.html" rel="bookmark" class="title">Yii2中SqlDataProvider用法示例&lowbar;php实例</a>
					<div>
						本文实例讲述了Yii2中SqlDataProvider用法.分享给大家供大家参考,具体如下: 第一种方法: $totalCount = Yii::$app-&gt;db-&gt;createComma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Zr4vb.html" rel="bookmark" class="title">浅析JS刷新框架中的其他页面 &amp;amp&semi;amp&semi;&amp;amp&semi;amp&semi; JS刷新窗口方法汇总&lowbar;javascript技巧</a>
					<div>
						先来看一个简单的例子:下面以三个页面分别命名为frame.html.top.html.bottom.html为例来具体说明如何做.frame.html 由上(top.html)下(bottom.htm ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
